package com.eactive.eai.batch.job.jobItem.ksnet;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_KSN25_0320 extends DefaultTelegram implements TelegramService
{

	private int     REAL_BYTE;         // 실 data byte수
    private int     SEND_LENGTH;
    private int     REAL_SEND_LENGTH;
    private int     SEQ_NO;
    private String  filename;
    private File file;
    private BufferedInputStream bis;
    private byte[] fileHeader;
    private byte[] fileData;

    public SEND_KSN25_0320() {  // 다른 전문과 달리 전문 번호가 없어 편의상 120번을 부여함
    }

    public boolean doExecute() {
    	try {
        	if (!setBlockAndSeqNO()) return false;
        	if ( !calculateSendLength() ) return false;
            //길이 필드 
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //송수신구분 수신요청[RJ] 송신요청[SJ] 송신확인[SR] 목록수신[RR] 비정상발생 종료요청 [QQ]
            compileField(1, "SJ", this.al_FieldProps[1]);

            //FILE NAME
            compileField(2, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[2]);

            //압축여부   압축[C] 비압축[U]
            compileField(3, "U", this.al_FieldProps[3]);

            //데이터부 크기
            compileField(4, "" + REAL_BYTE, this.al_FieldProps[4]);

            //전송일련번호
            compileField(5, "" + SEQ_NO, this.al_FieldProps[5]);

            //전송끝여부 마지막[EF] 기타 [  ]
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            if ( lnCurSize >= batchDoc.getBatchMsg().getHeader().getFileSize()){
                compileField(6, "EF", this.al_FieldProps[6]);
            }else{
                compileField(6, "", this.al_FieldProps[6]);
            }
            	
            //<< 전문 완성

            return true;

		} catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
		}
    }

    public boolean doPreExecute() {
        if (!super.doPreExecute()) return false;
        SEQ_NO = batchDoc.getBatchMsg().getBody().getSeqNum() + 1;
        return true;
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        return REAL_SEND_LENGTH;
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size() -1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += fileData.length;
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     */
    public int getCalculatedLength(int idx) {

        if (idx >= this.getFieldCount()) {
        	logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return fileData.length;
    }

    /**
     * 여기서는 파일을 닫는다.
     */
    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<this.al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            batchDoc.getBatchMsg().setTelegramBody(new String(fileData));

            batchDoc.getBatchMsg().getBody().setSeqNum(SEQ_NO);

            if ( getFieldValueString(6).equals("EF") ){
                //DB로그에 남길 파일 헤더,트레일러 내용 설정
                super.setFileHeaderAndTrailer(file);
            	LogUtil.setLogFileEnd(batchDoc);

                if ( bis != null ) {
                    bis.close();
                    bis = null;
                }
                logger.info("{}  doPostExecute called : file close", logHeader);
                long curSize = batchDoc.getBatchMsg().getBody().getCurFileSize();
                long totSize = batchDoc.getBatchMsg().getHeader().getFileSize();
                if ( curSize != totSize ){
                	logger.debug("[SEND_KSN25_0320:doPostExecute]-->" + curSize + "/" + totSize );
                    String[] msgArgs = new String[1];
                    msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                    String errCode = "BECEAIFJI029";
                    Exception e = new Exception("체크파일에 명시된 건수와 DATA 파일의 건수가 맞지 않습니다. \n"+
                    		                    "확인 바랍니다.");  
                    String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                    this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                    logger.error( e.getMessage(), e);
                	return false;
                }
            }
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
            	logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < batchDoc.getBatchMsg().getHeader().getSequenceSize()) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, fileData.length);

            // 20060419 add by khs for 전송상태 확인
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return fileData.length;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean setBlockAndSeqNO (){
        try {
        	if (!createFile()) {
        		logger.error("{}  file open failed", logHeader);
                return false;
            }

            REAL_BYTE = 0;                     // data 버퍼에 현재까지 채워진 공간
            int bufferSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            fileData = new byte[bufferSize];
            for ( int inx = 0; inx < bufferSize; inx++){
            	fileData[inx] = ' ';
            }
            int recSize = batchDoc.getBatchMsg().getHeader().getRecLen();
            byte[] readData = new byte[( (bufferSize - 100) / recSize ) * recSize];  

            if (fileHeader != null ){
                int headerLen = fileHeader.length;
                System.arraycopy( fileHeader, 0, fileData, 0, headerLen);
                REAL_BYTE = bis.read(readData);
                batchDoc.getBatchMsg().setFileHeader(new String(fileHeader));
                fileHeader = null;
                System.arraycopy(readData, 0, fileData, headerLen, REAL_BYTE);
                REAL_BYTE += headerLen;
            }else{
            	REAL_BYTE = bis.read(readData);
                System.arraycopy(readData, 0, fileData, 0, REAL_BYTE);
            }

            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            if ( lnCurSize >= batchDoc.getBatchMsg().getHeader().getFileSize()){
            	batchDoc.getBatchMsg().setFileTrailer(new String(fileData));
            }

            return true;

        } catch (Exception ex) {
        	logger.error("{} ★★★★★ 송신 파일 데이터 READ 시 오류 발생 !! ★★★★★", logHeader, ex);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(ex.toString());
            return false;
        }
    }
    
    private boolean createFile()
    {
        try {
        	bis = BatchOpenFileManager.getInstance().getBis(batchDoc.getBatchMsg().getHeader().getUUID() );
            if ( bis != null ) return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        int headerLen = TelegramKeys.KSNET_HEADER_LEN;
        fileHeader = new byte[headerLen];
        for (int inx = 0; inx < headerLen - 2; inx++) {
            fileHeader[inx] = ' ';
        }

        //        헤더 구분 : <<HEADER>>
        System.arraycopy( "<<HEADER>>".getBytes(), 0, fileHeader, 0, 10);

        String hdrInfo = batchDoc.getBatchMsg().getHeader().getHdrInfoName();
        //        송신자 ID :  송신자의 ID 체크파일에서 처리
        System.arraycopy( hdrInfo.getBytes(), 38, fileHeader, 10, 8);

        //        업체 구분:  송신자의 업체구분 코드
        //        정보 구분:  BODY의 정보구분 코드 (문서명)
        String infoGb = batchDoc.getBatchMsg().getHeader().getBizCode();
        System.arraycopy( infoGb.getBytes(), 0, fileHeader, 18, 5);

        //        수신자수로 추정
        System.arraycopy( "NN001".getBytes(), 0, fileHeader, 23, 5);

        //        수신자 ID :
        System.arraycopy( hdrInfo.getBytes(), 46, fileHeader, 28, 8);
        //        레코드 구분자 :  CR, LF
        fileHeader[headerLen-2] = '\r';
        fileHeader[headerLen-1] = '\n';

        SEQ_NO = 1;
        //요구송신 파일 Start DB로그
        try {
            LogUtil.setLogFileStart(batchDoc);
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

            this.filename = fileDir+ File.separator + fileNm;
            this.file = new File(this.filename);
            if (!file.exists()) // 파일이 없으면 리턴 False
            {
            	logger.debug("{}  the File does not exist!!! ["+this.filename+"]", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIJI022";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return false;
            }
            bis = new BufferedInputStream ( new FileInputStream(file) );
            BatchOpenFileManager.getInstance().addBis(batchDoc.getBatchMsg().getHeader().getUUID() , filename, bis);

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI021";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return false;
        }
        return true;
    }
}